// -*- C++ -*-
//
// ChSnoozer - put your thread to sleep, but let it wake up
//
// Copyright © 1997-1998 Arcane Dragon Software
//                       Chris Herborth (chrish@kagi.com)
//
// This is based on an idea I got from Jon Wätte in bedevtalk.
//
// $Id: ChSnoozer.h,v 1.6 1998/04/14 11:39:23 chrish Exp $

#ifndef libCh_SNOOZER_H
#define libCh_SNOOZER_H

#pragma once

#include <kernel/OS.h>
#include <support/SupportDefs.h>

class ChSnoozer
{
public:
	ChSnoozer( const char *name = "ChSnoozer" );
	virtual ~ChSnoozer( void );

	bool IsValid( void ) {
		return ( _snooze_sem < B_NO_ERROR ? false : true );
	}

	bool SleepFor( const bigtime_t sleep_time );
	status_t WakeUp( void );

private:
	ChSnoozer( const ChSnoozer& );		// Don't copy me
	ChSnoozer& operator=( ChSnoozer& );	// Don't assign me

	sem_id _snooze_sem;

	static char *_rcs_id;
};

#endif
